#import "RootViewController.h"
#import "PageDemoAppDelegate.h"

@implementation RootViewController

- (id)initWithAppDelegate:(id)appDelegate {
    self = [super init];
    if (self != nil) {
        
        /* ナビゲーションボタンの初期化 */
        credits = [[UIBarButtonItem alloc] initWithTitle:@"Copyright" 
                                                   style:UIBarButtonItemStylePlain
                                                  target:appDelegate 
                                                  action:@selector(credits)];
        self.navigationItem.rightBarButtonItem = credits;
        
        segmentedControl = [[UISegmentedControl alloc] initWithItems:nil];
        segmentedControl.segmentedControlStyle = UISegmentedControlStyleBar;
        
        [segmentedControl insertSegmentWithTitle:@"ウサギ" atIndex:0 animated:NO];
        [segmentedControl insertSegmentWithTitle:@"子馬" atIndex:1 animated:NO];
        
        [segmentedControl addTarget:self action:@selector(controlPressed:) forControlEvents:UIControlEventValueChanged];
        
        self.navigationItem.titleView = segmentedControl;
        segmentedControl.selectedSegmentIndex = 0;
        
    }
    return self;
}

- (void)controlPressed:(id)sender {
    [self setPage];
}

- (void)setPage {
    int index = segmentedControl.selectedSegmentIndex;
    
    if (index == 0) {
        textView.text = [NSString stringWithFormat:@"わ〜、ウサギだ！"];
    } else {
        textView.text = [NSString stringWithFormat:@"わ〜、子馬だぞ！"];
    }
}

- (void)loadView {
    CGRect bounds = [[UIScreen mainScreen] applicationFrame];
    [super loadView];
    
    textView = [[UITextView alloc] initWithFrame:bounds];
    textView.editable = NO;
    
    [self setPage];
    self.view = textView;
}

- (void)dealloc {
    [textView release];
    [super dealloc];
}

@end

@implementation CreditsViewController

- (id)initWithAppDelegate:(id)appDelegate {
    self = [super init];
    if (self != nil) {
        
        /* ナビゲーションボタンの初期化 */
        UIBarButtonItem *back = [[[UIBarButtonItem alloc] initWithTitle:@"Back" 
                                                                  style:UIBarButtonItemStylePlain
                                                                 target:appDelegate 
                                                                 action:@selector(back)] autorelease];
        self.navigationItem.backBarButtonItem = back;
    }
    return self;
}

- (void)loadView {
    [super loadView];
    
    textView = [[UITextView alloc] initWithFrame:[[UIScreen mainScreen] applicationFrame]];
    textView.editable = NO;
    textView.text = @"iPhone SDKアプリケーション開発\n" 
        "Copyright (c) 2009, オライリー・ジャパン";
    
    self.view = textView;
}

- (void)dealloc {
    [textView release];
    [super dealloc];
}

@end

