#import <QuartzCore/CAAnimation.h>
#import "RootViewController.h"
#import "FlipDemoAppDelegate.h"

@implementation RootViewController

- (id)init {
	self = [super init];
	if (self != nil) {
		/* デフォルトのページ */
		page = lastViewed = 5;
		
		/* ナビゲーションボタンの初期化 */
		prev = [[UIBarButtonItem alloc] initWithTitle:@"前へ" 
												style:UIBarButtonItemStylePlain
											   target:self 
											   action:@selector(prevpage)];
		self.navigationItem.leftBarButtonItem = prev;
		
		next = [[UIBarButtonItem alloc] initWithTitle:@"次へ" 
												style:UIBarButtonItemStylePlain
											   target:self 
											   action:@selector(nextpage)];
		self.navigationItem.rightBarButtonItem = next;
	}
	return self;
}

- (void)controlPressed:(id)sender {
	[self setPage];
}

- (void)setPage {
	/* 新たにアニメーションを生成する */
	CATransition *myTransition = [CATransition animation]; 
	myTransition.timingFunction = UIViewAnimationCurveEaseInOut;
	myTransition.type = kCATransitionPush;
	if (page > lastViewed) {
		myTransition.subtype = kCATransitionFromRight;
	} else {
		myTransition.subtype = kCATransitionFromLeft;
	}	
	
	/* アニメーションを最上位のビューのlayerに追加する */
	[self.view.layer addAnimation:myTransition forKey:nil];
	[self.view insertSubview:textView[page-1] atIndex:0];
	[textView[lastViewed-1] removeFromSuperview];
	
	lastViewed = page;
	
	prev.enabled = (page != 1);
	next.enabled = (page != 10);
}

- (void)prevpage {
	page--;
	[self setPage];
}

- (void)nextpage {
	page++;
	[self setPage];
}

- (void)loadView {
	CGRect bounds = [[UIScreen mainScreen] applicationFrame];
	[super loadView];
	
	view = [[UIView alloc] initWithFrame:bounds];
	bounds.origin.y = 0;
	
	for(int i = 0; i < 10; i++) {
		textView[i] = [[UITextView alloc] initWithFrame:bounds];
		textView[i].editable = NO;
		textView[i].text = [NSString stringWithFormat: @"ページ %d", i+1];
	}
	
	self.view = view;
	[self.view addSubview:textView[4]];
	
}

- (void)dealloc {
	for(int i = 0; i < 10; i++) {
		[textView[i] dealloc];
	}
	[next dealloc];
	[prev dealloc];
    [super dealloc];
}

@end

