#import "RootViewController.h"
#import "EndWorldAppDelegate.h"

@implementation RootViewController

- (id)init {
	self = [super init];
	if (self != nil) {
		/* ナビゲーションボタンを初期化 */
		endWorld = [[UIBarButtonItem alloc] initWithTitle:@"世界の終わり" 
													style:UIBarButtonItemStyleDone
												   target:self
												   action:@selector(endWorld)];
		self.navigationItem.rightBarButtonItem = endWorld;
	}
	
	return self;
}

- (void)loadView {
	CGRect bounds = [[UIScreen mainScreen] applicationFrame];
	[super loadView];
	
	textView = [[UITextView alloc] initWithFrame:bounds];
	textView.editable = YES;
	textView.text = @"世界の終わりにあたっての一言を入力し、「世界の終わり」を押してください。";
	
	self.view = textView;
}

- (void)endWorld {
	endWorldAlert = [[UIAlertView alloc] initWithTitle:@"世界の終わり"
											   message:@"警告：世界を終わらせようとしています。"
											  delegate:self
									 cancelButtonTitle:@"間違った" 
									 otherButtonTitles:@"やれ！", nil];
	[endWorldAlert show];
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex {
	if (alertView == endWorldAlert) {
		NSLog(@"%d番目のボタンが押されました", buttonIndex);
		
		UIAlertView *myAlert = [[UIAlertView alloc] initWithTitle:@"世界の終わり" 
														  message:nil
														 delegate:self
												cancelButtonTitle:nil 
												otherButtonTitles:@"OK", nil];
		if (buttonIndex == 0) {
			  myAlert.message = @"次はもう少し注意してくださいね！";
        [myAlert show];
        [alertView release];
		} else if (buttonIndex == 1) {
        [alertView release];
    
        UIActionSheet *mySheet 
        = [[UIActionSheet alloc] initWithTitle:@"本当に終わりにしますか？"
                                      delegate: self
                             cancelButtonTitle: @"キャンセル"
                        destructiveButtonTitle: @"終わりにする"
                             otherButtonTitles: nil];
      
        mySheet.destructiveButtonIndex = 0;
        [mySheet showInView:self.view];
        [mySheet release];
      
		
    } else {
			myAlert.message = @"不正なボタンです";
      [myAlert show];
      [alertView release];
		}
		
	}

	else if (alertView == endWorldConfirm) {
  
	
  }
} 

- (void)actionSheet:(UIActionSheet *)actionSheet 
clickedButtonAtIndex:(NSInteger)buttonIndex {
  /* ここでアクションシートを処理する */
  UIAlertView *myAlert;
  switch (buttonIndex) {
    case 0:
      NSLog(@"ボタン0を選択");
      [actionSheet dismissWithClickedButtonIndex:0 animated:YES];

      
      sleep(3); // 3秒スリープ
      exit(0); // 終了
      break;
    case 1:
      NSLog(@"ボタン1を選択");
      myAlert = [[UIAlertView alloc] initWithTitle:@"ああよかった" 
                                                        message:nil
                                                       delegate:self
                                              cancelButtonTitle:nil 
                                              otherButtonTitles:@"OK", nil];
      myAlert.message = @"次はもう少し注意してくださいね！";
      [myAlert show];
//      [alertView release];
      break;
    case 2:
      NSLog(@"ボタン2を選択");
      break;
      
    default:
      NSLog(@"その他を選択");
      break;
  }
  
}

- (void)dealloc {
	[textView dealloc];
	[endWorld dealloc];
	[super dealloc];
}

@end

