#import <Foundation/Foundation.h>
#import <AudioToolbox/AudioToolbox.h>
#import <AVFoundation/AVFoundation.h>

@interface AVMeterView : UIView {
	AVAudioPlayer *player;
	float cachedAveragePowerForChannel[2], cachedPeakPowerForChannel[2];
	CGRect avgMeterFrame[2], peakMeterFrame[2];
	UIImage *meterAveragePowerImage, *meterPeakPowerImage;
	BOOL updating;
	
	float meterSpacing;
	float meterHorizontalBorder;
	float meterVerticalBorder;
}

- (id)initWithFrame:(CGRect)frame;
- (void)startUpdating;
- (void)stopUpdating;

@property(nonatomic, retain) AVAudioPlayer *player;
@property(nonatomic, retain) UIImage *meterAveragePowerImage;
@property(nonatomic, retain) UIImage *meterPeakPowerImage;

@property(nonatomic, assign) float meterSpacing;
@property(nonatomic, assign) float meterHorizontalBorder;
@property(nonatomic, assign) float meterVerticalBorder;

@end
