#import "SoundExampleAppDelegate.h"
#import <AudioToolbox/AudioToolbox.h>

@implementation SoundExampleAppDelegate

// サウンドの再生が終わるとこの関数が呼ばれる
static void SoundFinished(SystemSoundID sample, void *info){
	AudioServicesDisposeSystemSoundID(sample);

}

- (void)applicationDidFinishLaunching:(UIApplication *)application {
    SystemSoundID soundID; // System Sound ID -- 再生するサウンドを登録するID
    NSBundle *bundle = [NSBundle mainBundle];
    NSURL *url = [NSURL fileURLWithPath:[bundle pathForResource:@"sound" ofType:@"aif"]];
    OSStatus err = AudioServicesCreateSystemSoundID((CFURLRef)url, &soundID);
    if(err){
        NSLog(@"システムサウンドの割り当てでエラー発生!");
	exit(-1);
    }
    /* サウンド終了時のコールバックを追加 */
    AudioServicesAddSystemSoundCompletion(soundID, NULL, NULL, SoundFinished, NULL);
    /* 再生する */
    AudioServicesPlaySystemSound(soundID);
}


- (void)dealloc {
    [super dealloc];
}


@end
