//
//  JokeServerViewController.m
//  JokeServer
//
//  Created by Chephes on 09/06/23.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "JokeServerViewController.h"
#import <sys/socket.h>
#import <netinet/in.h>

@implementation JokeServerViewController

static void AcceptCallBack(CFSocketRef socket, CFSocketCallBackType type, CFDataRef address,
							const void *data, void *info) {
	CFReadStreamRef readStream = NULL;
	CFWriteStreamRef writeStream = NULL;
	CFIndex bytes;
	char buffer[128];
	UInt8 recv_len = 0, send_len = 0;
	
	CFSocketNativeHandle sock = *(CFSocketNativeHandle *)data;
	
	char *punchline = info;
	
	CFStreamCreatePairWithSocket(kCFAllocatorDefault, sock, &readStream, &writeStream);

	if(!readStream || !writeStream){
		close(sock);
		NSLog(@"CFStreamCreatePairWithSocket() failed");
		return;
	}
	
	CFReadStreamOpen(readStream);
	CFWriteStreamOpen(writeStream);
	memset(buffer, 0, sizeof(buffer));
	while (!strchr(buffer, '\n') && recv_len < sizeof(buffer)) {
		bytes = CFReadStreamRead(readStream, ((UInt8 *) buffer) + recv_len, sizeof(buffer) - recv_len);
		if (bytes < 0) {
			NSLog(@"CFReadStreamRead() failed");
			close(sock);
			return;
		}
		recv_len += bytes;
	}
	
	while (send_len < strlen(punchline) + 1) {
		bytes = CFWriteStreamWrite(writeStream, ((UInt8 *)punchline) + send_len, strlen(punchline) + 1 - send_len);
		if (bytes < 0) {
			NSLog(@"CFWriteStreamWrite() failed");
			close(sock);
			return;
		}
		send_len += bytes;
	}
	
	CFWriteStreamClose(writeStream);
	CFReadStreamClose(readStream);
		
	close(sock);
	return;
}
		
/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


- (void)viewDidLoad {
    [super viewDidLoad];
	
	static char punchline[] = "To get to the other side!\n";
	int yes = 1;
	
	CFSocketContext CTX = {0, punchline, NULL, NULL, NULL};
	TCPServer = CFSocketCreate(kCFAllocatorDefault, PF_INET, SOCK_STREAM, IPPROTO_TCP, kCFSocketAcceptCallBack,
							   (CFSocketCallBack)&AcceptCallBack, &CTX);
	if (TCPServer == NULL) return;
	setsockopt(CFSocketGetNative(TCPServer), SOL_SOCKET, SO_REUSEADDR, (void *)&yes, sizeof(yes));
	
	struct sockaddr_in addr;
	memset(&addr, 0, sizeof(addr));
	
	addr.sin_len = sizeof(addr);
	addr.sin_family = AF_INET;
	addr.sin_port = htons(PORT);
	addr.sin_addr.s_addr = htonl(INADDR_ANY);
	
	NSData *address = [NSData dataWithBytes:&addr length:sizeof(addr)];
	if (CFSocketSetAddress(TCPServer, (CFDataRef)address) != kCFSocketSuccess) {
		NSLog(@"CFSocketSetAddress() failed");
		CFRelease(TCPServer);
		return;
	}
	CFRunLoopSourceRef sourceRef = CFSocketCreateRunLoopSource(kCFAllocatorDefault, TCPServer, 0);
	CFRunLoopAddSource(CFRunLoopGetCurrent(), sourceRef, kCFRunLoopCommonModes);
	CFRelease(sourceRef);
	
	NSLog(@"JokeServer start!");
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

@end
