#import "WhereYouAtViewController.h"

@implementation WhereYouAtViewController

- (void)loadView {
	[super loadView];
	textView = [[UITextView alloc] initWithFrame:self.view.frame];
	self.view = textView;
}

- (void)viewDidLoad {
	UIFont *mySystemFont = [UIFont systemFontOfSize:14.0];
	textView.font = mySystemFont;
	textView.text = @"Where you at? ...";
	gps = [[CLLocationManager alloc] init];
	gps.delegate = self;
	gps.desiredAccuracy = kCLLocationAccuracyBest;
	gps.distanceFilter = kCLDistanceFilterNone;
	[gps startUpdatingLocation];
}

- (void)locationManager:(CLLocationManager *)locationManager 
    didUpdateToLocation:(CLLocation *)newLocation 
	   fromLocation:(CLLocation *)oldLocation {
	textView.text = [NSString stringWithFormat:@"Where you at? ...\n\n"
					 "詳細情報: %@\n"
					 "経緯度: %f, %f\n"
					 "高度: %f\n"
					 "更新時刻: %@\n", 
					 newLocation.description,
					 newLocation.coordinate.latitude,
					 newLocation.coordinate.longitude,
					 newLocation.altitude,
					 newLocation.timestamp];
	UIFont *mySystemFont = [UIFont systemFontOfSize:20.0];
	textView.font = mySystemFont;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning];
}

- (void)dealloc {
	[textView release];
	[super dealloc];
}

@end
