//
//  EmailsViewController.m
//  Emails
//

#import "EmailsViewController.h"
#import <AddressBook/AddressBook.h>

@implementation EmailsViewController


- (void)loadView {
  
  [super loadView];
  
  ABAddressBookRef ab = ABAddressBookCreate();
  CFIndex count = ABAddressBookGetPersonCount(ab);
  //    NSLog(@"アドレス帳に記憶されているデータの数：%ld", count);
  NSArray *people = (NSArray *)ABAddressBookCopyArrayOfAllPeople(ab);
  NSString *out = [NSString stringWithFormat:@"簡易アドレス帳（%d人）\n", count];
  for (int i=0; i<count; i++) {
      ABRecordRef person = [people objectAtIndex:i];
      CFStringRef lastName = ABRecordCopyValue(person, kABPersonLastNameProperty);
      ABMultiValueRef emails = ABRecordCopyValue(person, kABPersonEmailProperty);
      CFStringRef email;
      if (ABMultiValueGetCount(emails) > 0) {
          email = ABMultiValueCopyValueAtIndex(emails, 0);
      }
      out = [out stringByAppendingFormat:@" %@さん: %@\n", (NSString *)lastName,
             (NSString *)email];
  }
  
  textView = [[UITextView alloc] initWithFrame:[[UIScreen mainScreen] applicationFrame]];
  textView.text = out;
  UIFont *mySystemFont = [ UIFont systemFontOfSize: 20.0 ];
  textView.font = mySystemFont;
  self.view = textView;  
}


- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

@end
