#import "ShootStuffUpViewController.h"

@implementation ShootStuffUpViewController

- (id) init {
    self = [super initWithStyle:UITableViewStyleGrouped];
    
    if (self != nil) {
        self.title = @"ゲーム設定";
    }
    return self;
}

- (void) loadView {
    [super loadView];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (void)didReceiveMemoryWarning {
    
    [super didReceiveMemoryWarning];
}

- (void)dealloc {
    [musicVolumeControl release];
    [gameVolumeControl release];
    [difficultyControl release];
    [shipStabilityControl release];
    [badGuyControl release];
    [debugControl release];
    [versionControl release];
    [super dealloc];
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 3;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    switch (section) {
        case(0):
            return 3;
            break;
        case(1):
            return 3;
            break;
        case(2):
            return 1;
            break;
    }
    
    return 0;
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section { 
    switch (section) {
        case(0):
            return @"ゲーム設定";
            break;
        case(1):
            return @"高度な設定";
            break;
        case(2):
            return @"プログラムについて";
            break;
    }
    return nil;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    NSString *CellIdentifier = [NSString stringWithFormat:@"%d:%d", [indexPath indexAtPosition:0],
       [indexPath indexAtPosition:1]];
    
    UITableViewCell *cell = [[tableView dequeueReusableCellWithIdentifier:CellIdentifier] retain];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier];
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        
        switch ([indexPath indexAtPosition:0]) {
            case(0):
                switch([indexPath indexAtPosition:1]) {
                    case(0):
                        musicVolumeControl = [[UISlider alloc] initWithFrame:CGRectMake(170.0, 0.0, 125.0, 50.0)];
                        musicVolumeControl.minimumValue = 0.0;
                        musicVolumeControl.maximumValue = 10.0;
                        musicVolumeControl.value = 3.5;
                        [cell addSubview: musicVolumeControl];
                        cell.textLabel.text = @"音楽の音量";
                        break;
                    case(1):
                        gameVolumeControl = [[UISlider alloc] initWithFrame:CGRectMake(170.0, 0.0, 125.0, 50.0)];
                        gameVolumeControl.minimumValue = 0.0;
                        gameVolumeControl.maximumValue = 10.0;
                        gameVolumeControl.value = 3.5;
                        [cell addSubview: gameVolumeControl];
                        cell.textLabel.text = @"ゲームの音量";
                        break;
                    case(2):
                        difficultyControl = [[UISegmentedControl alloc] initWithFrame:CGRectMake(170.0, 5.0, 125.0, 35.0)];
                        [difficultyControl insertSegmentWithTitle:@"易" atIndex:0 animated:NO];
                        [difficultyControl insertSegmentWithTitle:@"難" atIndex:1 animated:NO];
                        difficultyControl.selectedSegmentIndex = 0;
                        [cell addSubview:difficultyControl];
                        cell.textLabel.text = @"難易度";
                        break;
                }
                break;
            case(1):
                switch ([indexPath indexAtPosition:1]) {
                    case(0):
                        shipStabilityControl = [[UISlider alloc] initWithFrame:CGRectMake(170.0, 0.0, 125.0, 50.0) ];
                        shipStabilityControl.minimumValue = 0.0;
                        shipStabilityControl.maximumValue = 10.0;
                        shipStabilityControl.value = 3.5;
                        [cell addSubview:shipStabilityControl];
                        cell.textLabel.text = @"自機の安定性";
                        break;
                    case(1):
                        badGuyControl = [[UISwitch alloc] initWithFrame:CGRectMake(200.0, 10.0, 0.0, 0.0)];
                        badGuyControl.on = YES;
                        [cell addSubview:badGuyControl];
                        cell.textLabel.text = @"敵機";
                        break;
                    case(2):
                        debugControl = [[UISwitch alloc] initWithFrame:CGRectMake(200.0, 10.0, 0.0, 0.0)];
                        debugControl.on = NO;
                        [cell addSubview:debugControl];
                        cell.textLabel.text = @"デバッグ";
                        break;    
                }
                break;
            case(2):
                versionControl = [[UITextField alloc] initWithFrame:CGRectMake(170.0, 10.0, 125.0, 38.0)];
                versionControl.text = @"1.0.0-J Rev. B";
                [cell addSubview:versionControl];
                [versionControl setEnabled:NO];
                cell.textLabel.text = @"バージョン";
                break;
        }
    }
    
    return [cell autorelease];
    
}

@end
