#import "ImageFunAppDelegate.h"

@implementation ImageFunView

- (id)initWithFrame:(CGRect) rect {
    self = [super initWithFrame:rect];
    if (self != nil) {
        NSLog(@"パタンをロード中");
        NSURL *url = [NSURL URLWithString:@"http://www.zdziarski.com/demo/1.png"];
        pattern = [[UIImage alloc] initWithData:[NSData dataWithContentsOfURL:url]];
        
        NSLog(@"画像をロード中");
        NSURL *url2 = [NSURL URLWithString:@"http://www.zdziarski.com/demo/2.png"];
        image = [[UIImage alloc] initWithData:[NSData dataWithContentsOfURL:url2]];
        
        alpha = 0.0;
    }
    
    return self;
}

- (void)drawRect:(CGRect)rect {
    CGRect myRect;
    
    myRect.size = image.size;
    myRect.origin.x = (320.0 - image.size.width) / 2;
    myRect.origin.y = (460.0 - image.size.height) / 2;
    
    [pattern drawAsPatternInRect:rect];
    
    [image drawInRect:myRect blendMode:kCGBlendModeNormal alpha:alpha];
    
    [NSTimer scheduledTimerWithTimeInterval:0.01
                                      target:self
                                    selector:@selector(handleTimer:)
                                    userInfo:nil
                                     repeats:NO];
}

- (void) handleTimer:(NSTimer *) timer {
    if (alpha < 1.0) {
        alpha += 0.01;
        
        [self setNeedsDisplay];
    }
}

- (void)dealloc {
    [super dealloc];
}

@end

@implementation ImageFunAppDelegate

@synthesize window;


- (void)applicationDidFinishLaunching:(UIApplication *)application {    
    CGRect screenBounds = [[UIScreen mainScreen] applicationFrame];
    CGRect viewRect = screenBounds;
    viewRect.origin.x = viewRect.origin.y = 0;
    
    window = [[UIWindow alloc] initWithFrame:screenBounds];
    mainView = [[ImageFunView alloc] initWithFrame:viewRect];
    
    [window addSubview:mainView];
    [window makeKeyAndVisible];
}

- (void)dealloc {
    [mainView release];
    [window release];
    [super dealloc];
}

@end
