#import "NosePickerViewController.h"

@implementation NosePickerViewController

- (id)init {
    self = [super init];
    if (self != nil) {
        noses = [[NSMutableArray alloc] init];
        [noses addObject:@"真っ直ぐ鼻"];
        [noses addObject:@"ワシ鼻"];
        [noses addObject:@"上向き鼻"];
        [noses addObject:@"鉤鼻"];
        [noses addObject:@"曲がり鼻"];
        [noses addObject:@"メラネシア鼻"];
        [noses addObject:@"アフリカ鼻"];
        
        sizes = [[NSMutableArray alloc] init];
        [sizes addObject:@"小"];
        [sizes addObject:@"中"];
        [sizes addObject:@"大"];
        [sizes addObject:@"特大"];
        
        selection[0] = selection[1] = 0;
    }
    return self;
}

- (void)loadView {
    CGRect bounds = [[UIScreen mainScreen] applicationFrame];
    
    [super loadView];
    
    pickerView = [[UIPickerView alloc] initWithFrame:CGRectMake(0.0, bounds.size.height - 216.0, 0.0, 0.0)];
    pickerView.delegate = self;
    pickerView.dataSource = self;
    pickerView.showsSelectionIndicator = YES;
    [self.view addSubview:pickerView];
    
    textView = [[UITextView alloc] initWithFrame:CGRectMake(0.0, 0.0, bounds.size.width, bounds.size.height - 216.0)];
    textView.font = [UIFont fontWithName:@"Arial" size:18.0];
    textView.textAlignment = UITextAlignmentCenter;
    textView.editable = NO;
    
    
    [self updateText];
    [self.view addSubview:textView];
}

- (void)updateText {
    textView.text = [NSString stringWithFormat:@"%@%@ひとつ\nオーダー入ります！\n", [sizes objectAtIndex:selection[1]], [noses objectAtIndex:selection[0]]];
} 

- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView {
    return 2;
}

- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component {
    switch(component) {
        case(0):
            return [noses count];
            break;
        case(1):
            return [sizes count];
            break;
    }
    return 0;
}

- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component {
    switch (component) {
        case(0):
            return [noses objectAtIndex:row];
            break;
        case(1):
            return [sizes objectAtIndex:row];
    }
    return nil;
}

- (void)pickerView:(UIPickerView *)pickerView 
      didSelectRow:(NSInteger)row inComponent:(NSInteger)component
{
    
    selection[component] = row;
    [self updateText];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; 
}

- (void)dealloc {
    [pickerView release];
    [noses release];
    [sizes release];
    [super dealloc];
}

@end
