#import "DatePickerViewController.h"

@implementation DatePickerViewController

- (id)init {
    self = [super init];
    if (self != nil) {
        minDate = [[NSDate alloc] initWithString:@"1773-12-16 12:00:00 +0900"];
        maxDate = [[NSDate alloc] initWithString:@"1776-07-04 12:00:00 +0900"];
    }
    return self;
}

- (void)loadView {
    CGRect bounds = [[UIScreen mainScreen] applicationFrame];
    
    [super loadView];
    
    pickerView = [[UIDatePicker alloc] initWithFrame:CGRectMake(0.0, bounds.size.height - 216.0, 0.0, 0.0)];
    
    
    pickerView.minimumDate = minDate;
    pickerView.maximumDate = maxDate;
    pickerView.datePickerMode = UIDatePickerModeDate;
    pickerView.date = minDate;
    
    [pickerView addTarget:self action:
     @selector(dateChanged:) 
          forControlEvents:UIControlEventValueChanged
    ];
    
    [self.view addSubview:pickerView];
    
    textView = [[UITextView alloc] initWithFrame:CGRectMake(0.0, 0.0, bounds.size.width, bounds.size.height - 216.0)];
    textView.font = [UIFont fontWithName:@"Arial" size:22.0];
    textView.textColor = [UIColor redColor];
    textView.textAlignment = UITextAlignmentCenter;
    textView.text = [pickerView.date description];
    textView.editable = NO;
    
    [self.view addSubview:textView];
}

-(void)dateChanged:(id)sender {
    UIDatePicker *control = (UIDatePicker *) sender;
    NSDate *selectedDate = control.date;
    textView.text = [selectedDate description];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; 
}

- (void)dealloc {
    [pickerView release];
    [super dealloc];
}

@end
