#import "BigImageViewController.h"

@implementation BigImageViewController

- (id)init {
    self = [super init];
    if (self != nil) {
        imageView = [[UIImageView alloc] initWithImage:
		    [UIImage imageWithData:[NSData dataWithContentsOfURL:[NSURL URLWithString:@"http://forecast.weather.gov/wwamap/png/US.png"]]]];
    }
    return self;
}

- (void)loadView {
    [super loadView];
    CGRect bounds = [[UIScreen mainScreen] applicationFrame];
    
    scrollView = [[UIScrollView alloc] initWithFrame:bounds];
    scrollView.contentSize = imageView.frame.size;
    scrollView.maximumZoomScale = 3.0;
    scrollView.minimumZoomScale = 0.25;
    scrollView.delegate = self;
    scrollView.bounces = NO;
    [scrollView addSubview:imageView];
    
    self.view = scrollView;
}

- (UIView *)viewForZoomingInScrollView:(UIScrollView *)scrollView {
    return imageView;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}


- (void)dealloc {
    [UIScrollView release];
    [UIImageView release];
    [super dealloc];
}

@end
