
#import "SimpleDrawingViewController.h"
#import "DrawingView.h"

@implementation SimpleDrawingViewController

- (void)clear:(id)sender{
    [drawingView clear];
}

- (void)toggleColor:(id)sender{
    static BOOL isBlack = YES;
    isBlack = !isBlack;
    [drawingView toggleColor:isBlack];
}

- (void)setLineWidth:(id)sender{
    UISlider *slider = (UISlider *)sender;
    [drawingView setLineWidth:slider.value];
}

- (void)save:(id)sender{
    UIImage *image = [drawingView UIImage];
    UIImageWriteToSavedPhotosAlbum(image, self, @selector(image:didFinishSavingWithError:contextInfo:), NULL);
}

- (void)image:(UIImage *)image didFinishSavingWithError:(NSError *)error contextInfo:(void *)contextInfo{
	NSString *message = @"保存しました";
	if(error) message = @"エラーが起こりました！";
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"SimpleDrawing" message:message delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
}

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

@end
