//
//  AudioSessionViewController.m
//  AudioSession
//
//  Created by Norihisa Nagano
//  Copyright Qosmo 2009. All rights reserved.
//

#import "AudioSessionViewController.h"
@implementation AudioSessionViewController
@synthesize isPlaying;
@synthesize avPlayer;

static void interruption(void   *inClientData,
                         UInt32 inInterruptionState){
    
    //[3] inClientDataをViewControllerのインスタンスにキャスト
    AudioSessionViewController *controler = inClientData;    
    //割り込み開始
    if(inInterruptionState == kAudioSessionBeginInterruption){
        NSLog(@"Begin Interruption");
        if(controler.isPlaying){
            [controler.avPlayer stop];
        }
    }
    else{//割り込みの終了
        NSLog(@"End Interruption");
        //割り込み前に再生中であったなら再生する
        if(controler.isPlaying && controler.avPlayer){
            [controler.avPlayer play];
        }
    }
}

- (void)viewDidLoad{
    AudioSessionInitialize(NULL, NULL, 
                           interruption, //[1]コールバック関数のポインタ
                           self         //[2]AudioSessionViewController自身を渡す
                           );
    
    UInt32 sessionCategory = kAudioSessionCategory_MediaPlayback;
    AudioSessionSetProperty(kAudioSessionProperty_AudioCategory, 
                            sizeof (sessionCategory), 
                            &sessionCategory);
    AudioSessionSetActive(YES);// [3] Audio Sessionを有効にする

    NSString *path = [[NSBundle mainBundle ] pathForResource:@"sample" ofType:@"aif"];
    NSURL *url = [NSURL fileURLWithPath:path];
    avPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:nil];
    avPlayer.delegate = self;
    //  avPlayer.numberOfLoops = -1;
    [avPlayer play];
    isPlaying = YES;
}

- (void)audioPlayerDidFinishPlaying:(AVAudioPlayer *)player successfully:(BOOL)flag{
    [avPlayer release];
    isPlaying = NO;
}
@end
